/*
 ******************************* Creazione file *******************************
 *-------------------------------------|--------------------------------------*
 * Creatore : Marco Savegnago					Data di creazione : 30/03/2000
 * Codice   :
 *
 * Note:
 *
 *
 ******************************* Revisione file *******************************
 *-------------------------------------|--------------------------------------*
 * Revisore :                                  Data di revisione :
 * Versione : 0
 *
 * Note:
 *
 */


#ifndef __NTPCCIODevice_h__
#define __NTPCCIODevice_h__

#include	"..\uint128.h"
#include	"pccioframe.h"
#include	"ntpcfomtrace.h"
#include	"..\NTPCFOMioctl.h"


#define	PCFOM_MAX_CHANNELS			4
#define	PCFOM_REVISION_ID_ADDRESS	0x100

class NTPCFOMDevice_DriverManagedQueue 
: 
	public KDriverManagedQueueEx
{
public:
	SAFE_DESTRUCTORS;
	VOID StartIo(KIrp I);
};


//enum PCCIO_CMD
//{
const	UCHAR    PCCIO_CMD_DIRECT_MEM_RD	=	0;		// Lettura diretta della ram 
const	UCHAR    PCCIO_CMD_DIRECT_MEM_WR	=	1;		// Scrittura diretta sulla ram.

// Lasciare dopo l'ultimo comando diretto.
const	UCHAR    PCCIO_CMD_DIRECT_END		=	31;

const	UCHAR    PCCIO_CMD_LOOP_BACK_TST	=	32;		// Loop back del frame ricevuto.
const	UCHAR    PCCIO_CMD_MALLOC			=	33;     // Alloca un buffer e ne rende l'indirizzo.
const	UCHAR    PCCIO_CMD_FREE				=	34;     // Libera un buffer allocato.
const	UCHAR    PCCIO_CMD_RPC				=	35;     // Uso delle funzioni di remotizzazione console PC.

// Lasciare per ultimo.
const	UCHAR    PCCIO_CMD_END				=	127;
//};


//enum PCCFOM_CMD
//{
// Lasciare per primo.
// Serve per numerare i comandi in sequenza
// a quelli gia numerati in pccio.h
const	UCHAR    	PCCFOM_CMD_START							=	128;

const	UCHAR    	PCCFOM_CMD_TRACEW_CFG						=	129;		// Richiede la configurazione dei trace.
const	UCHAR    	PCCFOM_CMD_TRACEW_EN_SET					=	130;		// Imposta l'abilitazione dei TRACEW.
const	UCHAR    	PCCFOM_CMD_TRACEW_EN_TST					=	131;		// Richiede lo stato abilitazione dei TRACEW.
const	UCHAR    	PCCFOM_CMD_TRACEW_VALUE						=	132;   		// Richiede il valore ultimo e medio dei TRACEW.
const	UCHAR    	PCCFOM_CMD_SAMPLE_TIME						=	133;        // Imposta il periodo del campionamento.
const	UCHAR    	PCCFOM_CMD_GET_SAMPLE_XSUM					=	134;		// Richiede la somma dei prodotti tra i campioni.
const	UCHAR    	PCCFOM_CMD_INVERT_CH_SET					=	135;		// Imposta l'inversione del valore campionato
const	UCHAR    	PCCFOM_CMD_INVERT_CH_TST					=	136;		// Richiede lo stato dell'inversione del valore campionato

const	UCHAR    	PCCFOM_CMD_GET_SINGLE_VALUE					=	137;		// Richiede lo stato dell'inversione del valore campionato
const	UCHAR    	PCCFOM_CMD_GET_SINGLE_MEDIA_SUM				=	138;		// Richiede lo stato dell'inversione del valore campionato

const	UCHAR    	PCCFOM_CMD_GET_MULTIPLE_VALUE				=	139;		// Richiede lo stato dell'inversione del valore campionato
const	UCHAR    	PCCFOM_CMD_GET_MULTIPLE_MEDIA_SUM			=	140;		// Richiede lo stato dell'inversione del valore campionato

const	UCHAR    	PCCFOM_CMD_GET_SINGLE_XSUM_VALUE			=	141;		// Richiede lo stato dell'inversione del valore campionato
const	UCHAR    	PCCFOM_CMD_GET_MULTIPLE_XSUM_VALUE			=	142;		// Richiede lo stato dell'inversione del valore campionato
const	UCHAR    	PCCFOM_CMD_GET_SINGLE_TRACE_CONFIG			=	143;		// Richiede lo stato dell'inversione del valore campionato

const	UCHAR		PCCFOM_CMD_GET_SINGLE_TRACE_ENABLE			=	144;
const	UCHAR		PCCFOM_CMD_SET_SINGLE_TRACE_ENABLE			=	145;

const	UCHAR		PCCFOM_CMD_GET_SINGLE_TRACE_INVERT			=	146;
const	UCHAR		PCCFOM_CMD_SET_SINGLE_TRACE_INVERT			=	147;

const	UCHAR		PCCFOM_CMD_GET_MULTIPLE_TRACE_ENABLE		=	148;
const	UCHAR		PCCFOM_CMD_SET_MULTIPLE_TRACE_ENABLE		=	149;

const	UCHAR		PCCFOM_CMD_GET_MULTIPLE_TRACE_INVERT		=	150;
const	UCHAR		PCCFOM_CMD_SET_MULTIPLE_TRACE_INVERT		=	151;

const	UCHAR    	PCCFOM_CMD_GET_SAMPLING_DIVISOR_VALUE		=	152;		// Richiede il valore lo stato dell'inversione del valore campionato
const	UCHAR    	PCCFOM_CMD_SET_SAMPLING_DIVISOR_VALUE		=	153;		// Richiede lo stato dell'inversione del valore campionato
const	UCHAR    	PCCFOM_CMD_GET_FIRMWARE_VERSION				=	154;		// Richiede la versione del firmware alla scheda
const	UCHAR    	PCCFOM_CMD_GET_FOM_MODE						=	155;		// Richiede il modo di funzionamento della decodifica dei valori FOM
const	UCHAR    	PCCFOM_CMD_SET_FOM_MODE						=	156;		// Imposta  il modo di funzionamento della decodifica dei valori FOM

//	};


/*
enum PCCIO_CMD
{
	PCCIO_CMD_DIRECT_MEM_RD,    // Lettura diretta della ram
	PCCIO_CMD_DIRECT_MEM_WR,    // Scrittura diretta sulla ram.

// Lasciare dopo l'ultimo comando diretto.
	PCCIO_CMD_DIRECT_END = 31,

	PCCIO_CMD_LOOP_BACK_TST,// Loop back del frame ricevuto.
	PCCIO_CMD_MALLOC,       // Alloca un buffer e ne rende l'indirizzo.
	PCCIO_CMD_FREE,         // Libera un buffer allocato.
	PCCIO_CMD_RPC,          // Uso delle funzioni di remotizzazione console PC.

// Lasciare per ultimo.
	PCCIO_CMD_END = 127
};


enum PCCFOM_CMD
{
// Lasciare per primo.
// Serve per numerare i comandi in sequenza
// a quelli gia numerati in pccio.h
	PCCFOM_CMD_START = PCCIO_CMD_END+1,

	PCCFOM_CMD_TRACEW_CFG,       // Richiede la configurazione dei trace.
	PCCFOM_CMD_TRACEW_EN_SET,    // Imposta l'abilitazione dei TRACEW.
	PCCFOM_CMD_TRACEW_EN_TST,    // Richiede lo stato abilitazione dei TRACEW.
	PCCFOM_CMD_TRACEW_VALUE,   	 // Richiede il valore ultimo e medio dei TRACEW.
	PCCFOM_CMD_SAMPLE_TIME,		 // Imposta il periodo del campionamento.
	PCCFOM_CMD_GET_SAMPLE_XSUM,  // Richiede la somma dei prodotti tra i campioni.
	PCCFOM_CMD_INVERT_CH_SET,    // Imposta l'inversione del valore campionato
	PCCFOM_CMD_INVERT_CH_TST     // Richiede lo stato dell'inversione del valore campionato
};


// Struttura per la gestione del trace contenuti nella scheda PccFom.
typedef struct PCCFOM_TRACE_STR
{
	USHORT	w_address;        	// Indirizzo trace nella memoria della scheda PccFom.
	USHORT  w_size;       		// Dimensione del trace.
	USHORT  w_mediaSize;  		// Numero elementi per il calcolo della media.
	USHORT  w_value;      		// Valore dell'ultimo elemento inserito nel trace.
	USHORT  w_media;      		// Media dei valori contenuti nel trace.
	UCHAR   by_invertEnable;  	// Abilitazione alla inversione del valore campionato.
	UCHAR   by_channelEnable;   // Flag di abilitazione.

}PCCFOM_TRACE_STR;

// Struttura standard per la gestione della scheda PccFom.

typedef struct PCCFOM_STR
{
	float			 f_sampleXMedia01;// Media del prodotto tra i campioni dei canali 0 e 1
	float			 f_sampleXMedia23;// Media del prodotto tra i campioni dei canali 2 e 3
	UINT128			 ui128_sampleXSum01; // Somma del prodotto tra i campioni dei canali 0 e 1
	UINT128			 ui128_sampleXSum23; // Somma del prodotto tra i campioni dei canali 2 e 3
	PCCFOM_TRACE_STR p_trace[PCFOM_MAX_CHANNELS]; 	  // Trace scheda PccFom.

}PCCFOM_STR;
*/

const	UCHAR	PCFOM_IO_ERROR_READING	=	0x01;
const	UCHAR	PCFOM_IO_ERROR_WRITING	=	0x02;
const	UCHAR	PCFOM_IO_ERROR_WAITING	=	0x04;

enum	PCFOM_CH
{
	PCCFOM_CH0_0,
	PCCFOM_CH0_1,
	PCCFOM_CH0_2,
	PCCFOM_CH0_3,

	PCCFOM_CH1_0,
	PCCFOM_CH1_1,
	PCCFOM_CH1_2,
	PCCFOM_CH1_3
};

enum	PCFOM_XSUM_CH
{
	PCCFOM_XSUM_CH0_01,
	PCCFOM_XSUM_CH1_01
};

enum	PCFOM_SAMPLING_DIVISOR_ID
{
	PCCFOM_SAMPLING_CH01,
	PCCFOM_SAMPLING_CH23
};

enum	PCFOM_FOM_MODE
{
	PCCFOM_FOM_VER_1,
	PCCFOM_FOM_VER_2
};

class NTPCFOMDevice 
: 
	public KDevice

{
	// Constructors
public:
	SAFE_DESTRUCTORS;
	NTPCFOMDevice(ULONG Unit=0);
	~NTPCFOMDevice();

	// Member Functions
public:

	DEVMEMBER_DISPATCHERS
	DEVMEMBER_CANCELIRP		(NTPCFOMDevice, CancelQueuedIrp)

	// Load registry paramaters in constructor
	void	LoadRegistryParameters(void);
	void	SerialDeviceControl(KIrp I);
	
	//	IOCTL Handlers

	NTSTATUS NTPCFOM_IOCTL_GET_SINGLE_VALUE_Handler(KIrp I);
	NTSTATUS NTPCFOM_IOCTL_GET_SINGLE_MEDIA_SUM_Handler(KIrp I);	//	PCCFOM_CMD_GET_SINGLE_MEDIA_SUM
	NTSTATUS NTPCFOM_IOCTL_GET_SINGLE_XSUM_VALUE_Handler(KIrp I);
	NTSTATUS NTPCFOM_IOCTL_GET_MULTIPLE_VALUES_Handler(KIrp I);
	NTSTATUS NTPCFOM_IOCTL_GET_MULTIPLE_XSUM_VALUES_Handler(KIrp I);
	NTSTATUS NTPCFOM_IOCTL_GET_SINGLE_TRACE_CONFIG_Handler(KIrp I);

	NTSTATUS NTPCFOM_IOCTL_GET_SINGLE_TRACE_ENABLE_Handler(KIrp I);
	NTSTATUS NTPCFOM_IOCTL_SET_SINGLE_TRACE_ENABLE_Handler(KIrp I);

	NTSTATUS NTPCFOM_IOCTL_GET_SINGLE_TRACE_INVERT_Handler(KIrp I);
	NTSTATUS NTPCFOM_IOCTL_SET_SINGLE_TRACE_INVERT_Handler(KIrp I);

	NTSTATUS NTPCFOM_IOCTL_GET_SINGLE_TRACE_Handler(KIrp I);

	NTSTATUS NTPCFOM_IOCTL_GET_MULTIPLE_TRACE_ENABLE_Handler(KIrp I);
	NTSTATUS NTPCFOM_IOCTL_SET_MULTIPLE_TRACE_ENABLE_Handler(KIrp I);

	NTSTATUS NTPCFOM_IOCTL_GET_MULTIPLE_TRACE_INVERT_Handler(KIrp I);
	NTSTATUS NTPCFOM_IOCTL_SET_MULTIPLE_TRACE_INVERT_Handler(KIrp I);

	NTSTATUS NTPCFOM_IOCTL_RESET_TRACES_TIMER_Handler(KIrp I);

	NTSTATUS NTPCFOM_IOCTL_GET_SAMPLING_DIVISOR_VALUE_Handler(KIrp I);
	NTSTATUS NTPCFOM_IOCTL_SET_SAMPLING_DIVISOR_VALUE_Handler(KIrp I);
	
	NTSTATUS NTPCFOM_IOCTL_RESET_Handler(KIrp I);
	NTSTATUS NTPCFOM_IOCTL_RESTART_Handler(KIrp I);
	
	NTSTATUS NTPCFOM_IOCTL_GET_FIRMWARE_ID_Handler(KIrp I);
	NTSTATUS NTPCFOM_IOCTL_GET_FIRMWARE_VER_Handler(KIrp I);

	NTSTATUS NTPCFOM_IOCTL_GET_FOM_MODE_Handler(KIrp I);
	NTSTATUS NTPCFOM_IOCTL_SET_FOM_MODE_Handler(KIrp I);

	//	Device Driver Initialization

	NTSTATUS	InitResources(void);
	NTSTATUS	Add_PccIo(KResourceRequest *theRequest, KRegistryKey *Params);
	VOID		Invalidate(void);

	UCHAR	GetLastError()
	{
		return	m_LastError;
	}

#ifdef __COMMENT_ONLY
		// The following member functions are actually defined by the
		// a DEVMEMBER_XXX macro (such as DEVMEMBER_DISPATCHERS).
		// The macro __COMMENT_ONLY never gets defined.  These comment-only
		// definitions simply allow easy navigation to the functions within
		// the Developer Studio using the class browser.

	virtual NTSTATUS CleanUp(KIrp I); 				// COMMENT_ONLY
	virtual NTSTATUS Close(KIrp I);					// COMMENT_ONLY
	virtual NTSTATUS Create(KIrp I); 				// COMMENT_ONLY
	virtual NTSTATUS DeviceControl(KIrp I);			// COMMENT_ONLY

#endif

	// Member Data
protected:

	NTSTATUS		DeviceIoAbort(UCHAR		by_ErrorCode)
	{
		m_LastError	=	by_ErrorCode;

		return STATUS_SUCCESS;
	}

	//	Bus IO

	NTSTATUS		DeviceIoWrite(UCHAR		by_dato);
	NTSTATUS		DeviceIoWrite(USHORT	w_dato);

	NTSTATUS		IsFrameAvailable();
	SHORT			DeviceIoRead();
	LONG			DeviceIoReadW();

	NTSTATUS		DecodeIo(PCCIO_FR_STR**	p_frame, BOOLEAN	b_TxMode);
	NTSTATUS		DecodeRx(PCCIO_FR_STR*	p_frame);

	NTSTATUS		DeviceTxFrame(PCCIO_FR_STR*   p_frameTx);
	PCCIO_FR_STR*	DeviceRxFrame();
	PCCIO_FR_STR*	DeviceIoDirectFrameRead(USHORT w_Arg, USHORT w_Size);
	NTSTATUS		DeviceIoDirectFrameWrite(PCCIO_FR_STR*   p_Frame);

	NTSTATUS		DeviceIo(PCCIO_FR_STR**	p_frame, BOOLEAN	b_TxMode);
	NTSTATUS		DeviceIoMemWrite(USHORT w_address, USHORT w_size, UCHAR* pby_data);
	NTSTATUS		DeviceIoMemRead(UCHAR* pby_data, USHORT w_address, USHORT w_size);
	NTSTATUS		DeviceIoDirectFrame(PCCIO_FR_STR*   p_Frame);

	//	Device Firmware management

	NTSTATUS		DeviceIsFirmwareRunning();
	NTSTATUS		LoadDeviceFirmware();

	//	PCCFOM_CMD_XXX	Handler
	
	NTSTATUS		GetSingleValue(USHORT	w_Index, USHORT* pw_Value, USHORT* pw_Average);	//	Handle	PCCFOM_CMD_GET_SINGLE_VALUE
	NTSTATUS		GetSingleMediaSum(USHORT	w_Index, PULONG	pdw_Value);
	NTSTATUS		GetMultipleValues(PUSHORT pw_Values, PUSHORT pw_Avgerages);			//	Handle	PCCFOM_CMD_GET_MULTIPLE_VALUE
	
	NTSTATUS		GetSingleXSUMValue(USHORT	w_Index, PUSHORT pw_sampleXSumCt, PUINT128 pint128_XSum);	//	Handle	PCCFOM_CMD_GET_SINGLE_XSUM_VALUE
	NTSTATUS		GetMultipleXSUMValues(PUSHORT pw_sampleXSumCt, PUINT128 pint128_XSumCH0_01, PUINT128 pint128_XSumCH1_01);	//	Handle	PCCFOM_CMD_GET_MULTIPLE_XSUM_VALUE

	NTSTATUS		GetSingleTraceConfig(USHORT	w_Index, PNTPCFOM_IOCTL_GET_SINGLE_TRACE_CONFIG_BUFFER	Buffer);

	NTSTATUS		SetTraceEnable(UCHAR by_TraceCh);

	NTSTATUS		ResetTracesTimer();

	NTSTATUS		Reset();
	NTSTATUS		Restart();
	NTSTATUS		GetSingleTraceEnable(USHORT	w_Index, PUSHORT	pw_Value);
	NTSTATUS		SetSingleTraceEnable(USHORT	w_Index, USHORT		w_Value);
	NTSTATUS		GetSingleTraceInvert(USHORT	w_Index, PUSHORT	pw_Value);
	NTSTATUS		SetSingleTraceInvert(USHORT	w_Index, USHORT		w_Value);

	NTSTATUS		GetMultipleTraceEnable(PUSHORT	pw_Value);
	NTSTATUS		SetMultipleTraceEnable(USHORT	w_Value);
	NTSTATUS		GetMultipleTraceInvert(PUSHORT	pw_Value);
	NTSTATUS		SetMultipleTraceInvert(USHORT	w_Value);

	NTSTATUS		GetTrace(UCHAR by_TraceCh, PNTPCFOM_IOCTL_CHANNEL_TRACE_BUFFER	pValue);
	NTSTATUS		GetFirmwareID(PUCHAR	pc_Buffer);
	NTSTATUS		GetFirmwareVersion(PUSHORT	pw_MajorVersion, PUSHORT	pw_MinorVersion);
	
	NTSTATUS		SetSamplingDivisorValue(USHORT	w_Index, USHORT	w_Ch23DivisorValue);
	NTSTATUS		GetSamplingDivisorValue(USHORT	w_Index, PUSHORT	pw_Ch23DivisorValue);

	NTSTATUS		GetFOMMode(PUSHORT	pw_Mode);
	NTSTATUS		SetFOMMode(USHORT	w_Mode);
	
	//	Helper
	NTSTATUS		SysDelay(ULONG dw_Timeout);
	NTSTATUS		ValidateTraceID(UCHAR by_TraceCh);
	NTSTATUS		ConvertH8300ToPCTrace(PC_TRACE_H8300_STR* p_traceH8300, PC_TRACE_PC_STR* p_trace);
	NTSTATUS		ConvertPCTraceToIoctlBuffer(PC_TRACE_PC_STR*	p_Trace, NTPCFOM_IOCTL_CHANNEL_TRACE_BUFFER* p_TraceBuffer);

	// Obsolete	
	NTSTATUS		GetConfig();		// Handle PCCFOM_CMD_TRACEW_CFG
	NTSTATUS		GetTraceWValue();	// Handle PCCFOM_CMD_TRACEW_VALUE
	NTSTATUS		GetTraceInvert();
	NTSTATUS		SetTraceInvert();
	NTSTATUS		GetSampleXSUM(PUSHORT pw_sampleXSumCt, PUINT128 puint128_XSumCH0_01, PUINT128 puint128_XSumCH1_01);	//	Obsolete
	
	NTSTATUS		GetTraceEnable();
	NTSTATUS		SetTraceEnable();

	// Unit number for this device instance
	ULONG			m_Unit;
		// Used in constructor/destructor to hold registry path
	KUnitizedName*	m_RegPath;

	NTPCFOMDevice_DriverManagedQueue m_DriverManagedQueue;
	
	//	Board parameter taken from registry

	ULONG				m_IoBaseAddress;
	ULONG				m_IoIrq;
	ULONG				m_IoTimeout;
	ULONG				m_IoEnableIrq;
	PWSTR				m_FirmwareImage;

	ULONG				m_InvertCH0_0;
	ULONG				m_InvertCH0_1;
	ULONG				m_InvertCH0_2;
	ULONG				m_InvertCH0_3;
	ULONG				m_InvertCH0_4;
	ULONG				m_InvertCH0_5;
	ULONG				m_InvertCH0_6;
	ULONG				m_InvertCH0_7;

	ULONG				m_InvertCH1_0;
	ULONG				m_InvertCH1_1;
	ULONG				m_InvertCH1_2;
	ULONG				m_InvertCH1_3;
	ULONG				m_InvertCH1_4;
	ULONG				m_InvertCH1_5;
	ULONG				m_InvertCH1_6;
	ULONG				m_InvertCH1_7;

	ULONG				m_SyncTraceTimerSync;
	ULONG				m_CH01SamplingDivisor;
	ULONG				m_CH23SamplingDivisor;

	KIoRange			m_PccIo;
	KIoRegister			m_PortRegData;
	KIoRegister			m_PortRegStatus;
	KIoRegister			m_PortRegIrqRes;
	KIoRegister			m_PortRegMode1;
	KIoRegister			m_PortRegMode2;
	KIoRegister			m_PortRegReset;
	KIoRegister			m_PortRegDoIrq;

	UCHAR				m_LastError;

	USHORT				w_address[PCFOM_MAX_CHANNELS];        	// Indirizzo trace nella memoria della scheda PccFom.
	USHORT				w_size[PCFOM_MAX_CHANNELS];       		// Dimensione del trace.
	USHORT				w_averageSize[PCFOM_MAX_CHANNELS];  		// Numero elementi per il calcolo della media.

	UCHAR				by_invertEnable[PCFOM_MAX_CHANNELS];  	// Abilitazione alla inversione del valore campionato.
	UCHAR				by_channelEnable[PCFOM_MAX_CHANNELS];   // Flag di abilitazione.


	USHORT				w_value[PCFOM_MAX_CHANNELS];      		// Valore dell'ultimo elemento inserito nel trace.
	USHORT				w_average[PCFOM_MAX_CHANNELS];      		// Media dei valori contenuti nel trace.

	USHORT				w_sampleXSumCt;		// Numero di campioni presenti nel trace
	UINT128				ui128_sampleXSumCH0_01; // Somma del prodotto tra i campioni dei canali 0 e 1
	UINT128				ui128_sampleXSumCH1_01; // Somma del prodotto tra i campioni dei canali 2 e 3
	
};

/******************************** Definizioni *********************************
*--------------------------------------|--------------------------------------*/

//	Dato usato per scrittura dummy nella porta di comunicazione con il device

const	UCHAR	PC_PCCIO_DUMMY_DATA	=	0xaa;

//	Dimensione massima dei frame di lettura e scrittura diretta memoria PCC

#define	PC_PCC_DIRECT_MEM_MAX_SIZE		10000

// Codici di ritorno funzione PCPccIOLoad()
#define PC_PCCIO_LD_OK  		    	0 // Nessun errore,prog. caricato normalmente
#define PC_PCCIO_LD_BAD_POINTER			1 // NULL Pointer passati alla funzione PCPccIOLoad()
#define PC_PCCIO_LD_FILE_TOO_BIG		2 // Il file del prog. e' troppo grande (max 31616 byte)
#define PC_PCCIO_LD_NO_MEM 				3 // Non c'e' memoria sufficente per caricare il prog.
#define PC_PCCIO_LD_IO_ERROR    		4 // Errore di comunicazione in scrittura con PCC.
#define PC_PCCIO_LD_VERIFY_ERROR   		5 // Errore di verifica del programma caricato.
#define PC_PCCIO_LD_BAD_RUN_TEST		6 // Il prog.lanciato non gira correttamente


#define PC_PCCIO_REG_DATA		0 // Lettura scrittura dato
#define PC_PCCIO_REG_STATUS		1 // Lettura status scheda
#define PC_PCCIO_REG_IRQ_RES	2 // Scrittura con dummy dato x reset int request
#define PC_PCCIO_REG_MODE1		3 // Scrittura modo 1 di funzionamento scheda      
#define PC_PCCIO_REG_MODE2		4 // Scrittura modo 1 di funzionamento scheda      
#define PC_PCCIO_REG_RESET		5 // Scrittura con dummy dato x reset scheda     
#define PC_PCCIO_REG_DO_IRQ		6 // Scrittura con dummy dato x interrupt        

// Macro per scrivere su un registro della scheda Pcc.
// Il parametro P  il puntatore alla struttura PCCIO_PORT_STR.
// Il parametro R e' il registro da scrivere.
// Il parametro D e' il dato da scrivere nel registro.
//
#define PC_PCCIO_REG_WR(R,D)      (m_PccIo[(R)]	=	(D))

// Macro per leggere da un registro della scheda Pcc.
// Il parametro P  il puntatore alla struttura PCCIO_PORT_STR.
// Il parametro R e' il registro da leggere.
//
#define PC_PCCIO_REG_RD(R)			(m_PccIo[(R)])

// Macro per testare un bit di un registro.
// Il parametro P  il puntatore alla struttura PCCIO_PORT_STR.
// Il parametro R e' il registro da scrivere.
// Il parametro N e' il numero del bit da testare (da 0 a 7).
//
#define PC_PCCIO_REG_BIT_TST(R,N) ((PC_PCCIO_REG_RD(R)>>(N))&0x01)

// Macro per scrivere su un registro della scheda Pcc il dato PC_PCCIO_DUMMY_DATA.
// Viene usata per accedere ad un registro della scheda in scrittura dove il dato
// scritto non ha importanza perche' non viene usato.
// Il parametro P  il puntatore alla struttura PCCIO_PORT_STR.
// Il parametro R e' il registro da scrivere.
//
#define PC_PCCIO_REG_WR_DUMMY(R)	PC_PCCIO_REG_WR(R,PC_PCCIO_DUMMY_DATA)

// Macro per verificare se e' questa la scheda Pcc che ha generato interrupt al PC.
// Il parametro P  il puntatore alla struttura PCCIO_PORT_STR.
//
#define PC_PCCIO_IRQ_TST			PC_PCCIO_REG_BIT_TST(PC_PCCIO_REG_STATUS,4)

// Macro per resettare il flag di interrupt request nella scheda Pcc.
// Il parametro P  il puntatore alla struttura PCCIO_PORT_STR.
//
#define PC_PCCIO_IRQ_RES 			PC_PCCIO_REG_WR_DUMMY(PC_PCCIO_REG_IRQ_RES)

// Macro per impostare il modo (H8325) nella scheda Pcc.
// Il parametro P  il puntatore alla struttura PCCIO_PORT_STR.
//

#define PC_PCCIO_MODE1_SET			(m_PortRegMode1	=	PC_PCCIO_DUMMY_DATA)
#define PC_PCCIO_MODE2_SET			(m_PortRegMode2	=	PC_PCCIO_DUMMY_DATA)

// Macro per resettare la scheda Pcc.
// Il parametro P  il puntatore alla struttura PCCIO_PORT_STR.
//

#define	PC_PCCIO_RESET				(m_PortRegReset	=	PC_PCCIO_DUMMY_DATA)

// Macro per resettare il trace timer della scheda Pcc

#define	PC_PCCFOM_TRACE_TIMER_RESET	(m_PortRegDoIrq	=	PC_PCCIO_DUMMY_DATA)


// Macro per leggere il modo (H8325) di funzionamento della scheda Pcc.
// Il parametro P  il puntatore alla struttura PCCIO_PORT_STR.
//

#define PC_PCCIO_MODE_RD			((m_PortRegStatus>>2)&0x03)

// Macro per scrivere un byte sul bus di comunicazione.

#define	PC_PCCIO_PORT_WR(D)			(m_PortRegData=(D))

// Macro per leggere un byte sul bus di comunicazione.

#define	PC_PCCIO_PORT_RD			(m_PortRegData)

// Macro per testare lo stato del segnale di busy in lettura.
#define	PC_PCCIO_RD_BUSY_TST		(UCHAR(m_PortRegStatus)&0x01)

// Macro per testare lo stato del segnale di busy in scrittura.
#define	PC_PCCIO_WR_BUSY_TST		(UCHAR(m_PortRegStatus)&0x02)

#endif		// __NTPCCIODevice_h__
